【BZOJ2157】旅游 裸树链剖分

#include <stdio.h>
int main()
{
	puts("转载请注明出处[vmurder]谢谢");
	puts("网址:blog.csdn.net/vmurder/article/details/43965845");
}

重写大发好!!!!!

****什么题解都没有,水题一道,

挂了就去调,调不过就去重写。

代码:

#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define N 20100
#define ls (note<<1)
#define rs (note<<1|1)
#define inf 0x3f3f3f3f
using namespace std;
struct KSD
{
	int v,len,next;
}e[N<<1];
int head[N],cnt;
inline void add(int u,int v,int len)
{
	e[++cnt].v=v;
	e[cnt].len=len;
	e[cnt].next=head[u];
	head[u]=cnt;
}
int dep[N],pos[N],road[N],crs[N];
int fa[N],top[N],son[N];
int dfs1(int x,int p)
{
	int i,v,size=1,huge=0;
	fa[x]=p,dep[x]=dep[p]+1;
	for(i=head[x];i;i=e[i].next)
	{
		v=e[i].v;
		if(v==p)continue ;
		int temp=dfs1(v,x);size+=temp;
		if(huge<temp)son[x]=v,huge=temp;
		crs[i>>1]=v;
	}
	return size;
}
void dfs2(int x,int p)
{
	int i,v;
	top[x]=p,pos[x]=++cnt;
	if(son[x])dfs2(son[x],p);
	for(i=head[x];i;i=e[i].next)
	{
		v=e[i].v;
		if(v==son[x])road[pos[son[x]]]=e[i].len;
		if(v==son[x]||v==fa[x])continue ;
		road[cnt+1]=e[i].len;
		dfs2(v,v);
	}
}
struct Segment_Tree
{
	int l,r,sum;
	int mx,mi,c;
	bool f,rev;
}s[N<<2];
inline void pushup(int note)
{
	s[note].mx=max(s[ls].mx,s[rs].mx);
	s[note].mi=min(s[ls].mi,s[rs].mi);
	s[note].sum=s[ls].sum+s[rs].sum;
}
inline void pushdown(int note) // 覆盖的优先级高
{
	if(s[note].f)
	{
		s[note].rev=s[note].f=0;
		s[note].mx=s[note].mi=s[note].c;
		s[note].sum=(s[note].r-s[note].l+1)*s[note].c;

		if(s[note].l<s[note].r)
		{
			s[ls].c=s[rs].c=s[note].c;
			s[ls].f=s[rs].f=1;
			s[ls].rev=s[rs].rev=0;
		}
	}
	else if(s[note].rev)
	{
		s[note].rev=0;
		swap(s[note].mx,s[note].mi);
		s[note].mx*=(-1),s[note].mi*=(-1);
		s[note].sum*=(-1);

		if(s[note].l<s[note].r)
		{
			s[ls].c*=(-1),s[rs].c*=(-1);
			s[ls].rev^=1,s[rs].rev^=1;
		}
	}
}
void build(int note,int l,int r)
{
	s[note].l=l,s[note].r=r;
	if(l==r)
	{
		s[note].mx=s[note].mi=s[note].sum=road[l];
		return ;
	}
	int mid=l+r>>1;
	build(ls,l,mid);
	build(rs,mid+1,r);
	pushup(note);
}
void cover(int note,int l,int r,int x)
{
	if(s[note].l==l&&r==s[note].r)
	{
		s[note].c=x,s[note].f=1;
		pushdown(note);
		return ;
	}
	pushdown(note);
	int mid=s[note].l+s[note].r>>1;
	if(r<=mid)cover(ls,l,r,x),pushdown(rs);
	else if(l>mid)cover(rs,l,r,x),pushdown(ls);
	else cover(ls,l,mid,x),cover(rs,mid+1,r,x);
	pushup(note);
}
void rever(int note,int l,int r)
{
	if(s[note].l==l&&r==s[note].r)
	{
		s[note].c*=(-1),s[note].rev^=1;
		pushdown(note);
		return ;
	}
	pushdown(note);
	int mid=s[note].l+s[note].r>>1;
	if(r<=mid)rever(ls,l,r),pushdown(rs);
	else if(l>mid)rever(rs,l,r),pushdown(ls);
	else rever(ls,l,mid),rever(rs,mid+1,r);
	pushup(note);
}
int query(int note,int l,int r,int f) // 0sum 1max 2min
{
	pushdown(note);
	if(s[note].l==l&&r==s[note].r)
	{
		if(f==0)return s[note].sum;
		else if(f==1)return s[note].mx;
		else return s[note].mi;
	}
	int mid=s[note].l+s[note].r>>1;
	if(r<=mid)return query(ls,l,r,f);
	else if(l>mid)return query(rs,l,r,f);
	else {
		int a=query(ls,l,mid,f);
		int b=query(rs,mid+1,r,f);
		if(f==0)return a+b;
		else if(f==1)return max(a,b);
		else return min(a,b);
	}
}
inline void Cover(int a,int b){cover(1,pos[crs[a]],pos[crs[a]],b);}
inline void Rever(int a,int b)
{
	for(int A=top[a],B=top[b];A!=B;a=fa[A],A=top[a])
	{
		if(dep[A]<dep[B])swap(A,B),swap(a,b);
		rever(1,pos[A],pos[a]);
	}
	if(dep[a]<dep[b])swap(a,b);
	if(a!=b)rever(1,pos[b]+1,pos[a]);
}
inline int Query(int a,int b,int f)
{
	int ans;
	if(f==0)ans=0;
	else if(f==1)ans=-inf;
	else ans=inf;
	for(int A=top[a],B=top[b];A!=B;a=fa[A],A=top[a])
	{
		if(dep[A]<dep[B])swap(A,B),swap(a,b);
		int temp=query(1,pos[A],pos[a],f);
		if(f==0)ans+=temp;
		else if(f==1)ans=max(ans,temp);
		else ans=min(ans,temp);
	}
	if(dep[a]<dep[b])swap(a,b);
	if(a!=b)
	{
		int temp=query(1,pos[b]+1,pos[a],f);
		if(f==0)ans+=temp;
		else if(f==1)ans=max(ans,temp);
		else ans=min(ans,temp);
	}
	return ans;
}
int main()
{
	freopen("test.in","r",stdin);
//	freopen("test.out","w",stdout);

	int i,j,k;
	int a,b,c;
	int n,m;

	scanf("%d",&n);
	for(cnt=i=1;i<n;i++)
	{
		scanf("%d%d%d",&a,&b,&c);
		add(a+1,b+1,c),add(b+1,a+1,c);
	}
	cnt=0,dfs1(1,1),dfs2(1,1);
	build(1,1,n);

	char src[5];
	scanf("%d",&m);
	while(m--)
	{
		scanf("%s%d%d",src,&a,&b);
		if(src[0]=='C')Cover(a,b);
		else if(src[0]=='N')Rever(a+1,b+1);
		else if(src[2]=='M')printf("%d\n",Query(a+1,b+1,0));
		else if(src[2]=='X')printf("%d\n",Query(a+1,b+1,1));
		else if(src[2]=='N')printf("%d\n",Query(a+1,b+1,2));
	}
	return 0;
}
时间: 2024-09-30 10:59:05

【BZOJ2157】旅游 裸树链剖分的相关文章

HDU 5052 Yaoge’s maximum profit 裸树链剖分 2014 ACM/ICPC Asia Regional Shanghai Online

题意: 给定n个点的带点权树. 下面n行给出每个点点权表示每个点买卖鸡腿的价格 下面n-1行给出树边 下面Q个操作 Q行 u, v, val 从u走到v,过程中可以买一个鸡腿,然后到后面卖掉,输出max(0, 最大的收益) 然后给[u,v]路径上点点权+=val 思路: 树链剖分裸题 屌丝题解:点击打开链接 #pragma comment(linker, "/STACK:1024000000,1024000000") #include <cstdio> #include &

P1505 [国家集训队]旅游【树链剖分】

题目描述 Ray 乐忠于旅游,这次他来到了T 城.T 城是一个水上城市,一共有 N 个景点,有些景点之间会用一座桥连接.为了方便游客到达每个景点但又为了节约成本,T 城的任意两个景点之间有且只有一条路径.换句话说, T 城中只有N ? 1 座桥. Ray 发现,有些桥上可以看到美丽的景色,让人心情愉悦,但有些桥狭窄泥泞,令人烦躁.于是,他给每座桥定义一个愉悦度w,也就是说,Ray 经过这座桥会增加w 的愉悦度,这或许是正的也可能是负的.有时,Ray 看待同一座桥的心情也会发生改变. 现在,Ray

bzoj 2157: 旅游【树链剖分+线段树】

裸的树链剖分+线段树 但是要注意一个地方--我WA了好几次才发现取完相反数之后max值和min值是要交换的-- #include<iostream> #include<cstdio> using namespace std; const int N=200005; int n,m,h[N],cnt,de[N],va[N],fa[N],si[N],hs[N],fr[N],id[N],tot,rl[N]; char c[10]; struct qwe { int ne,no,to,va

BZOJ 2157 旅游(树链剖分+线段树)

[题目链接] http://www.lydsy.com/JudgeOnline/problem.php?id=2157 [题目大意] 支持修改边,链上查询最大值最小值总和,以及链上求相反数 [题解] 树链剖分,然后线段树维护线段操作即可. [代码] #include <cstdio> #include <algorithm> #include <cstring> using namespace std; const int INF=~0U>>1; const

BZOJ 3631: [JLOI2014]松鼠的新家( 树链剖分 )

裸树链剖分... ------------------------------------------------------------------- #include<bits/stdc++.h> using namespace std; const int maxn = 300009; struct edge { int to; edge* next; } E[maxn << 1], *pit = E, *head[maxn]; inline void add(int u,

【BZOJ-4515】游戏 李超线段树 + 树链剖分 + 半平面交

4515: [Sdoi2016]游戏 Time Limit: 40 Sec  Memory Limit: 256 MBSubmit: 304  Solved: 129[Submit][Status][Discuss] Description Alice 和 Bob 在玩一个游戏. 游戏在一棵有 n 个点的树上进行.最初,每个点上都只有一个数字,那个数字是 123456789123456789. 有时,Alice 会选择一条从 s 到 t 的路径,在这条路径上的每一个点上都添加一个数字.对于路径上

BZOJ2157: 旅游 树链剖分 线段树

http://www.lydsy.com/JudgeOnline/problem.php?id=2157 在对树中数据进行改动的时候需要很多pushdown(具体操作见代码),不然会wa,大概原因和线段树区间修改需要很多pushup是一样的. 这个轻重链的方法特别好用,虽然第一次写树链剖分但是容易理解又有优秀复杂度的结构让人情不自禁orz. (后来发现很久以前学lca的时候就学了树链剖分只不过忘了,mdzz) 因为忘了去掉测试代码的freopen,re了4次(虽然有三次就算不re也wa),发现一

【BZOJ1036】【ZJOI2008】树的统计Count 树链剖分裸题

题解:裸的,没什么好说的. 树链剖分不会的先理解一下重链轻链,然后直接扒我代码理解就行了. 贴代码: #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #define N 30100 #define inf 0x3f3f3f3f using namespace std; struct KSD { int u,v,next; }e[N<<1];

bzoj 1036 树链剖分+线段树 裸题

HYSBZ - 1036 题意:中文题 思路:树链剖分裸题,线段树写得比较搓,(在线段树上修改节点u的时候应该修改u映射到线段树后的节点序号,这里wa了半年,真的是半年) AC代码: #include "iostream" #include "string.h" #include "stack" #include "queue" #include "string" #include "vector